# -*- coding: utf-8 -*-
"""
Created on Sat Oct 14 00:24:28 2017
　　Scraping_try_2.py
  ・日経平均先物の価格をスクレイピングして、DLLに書き込む（無限ﾙｰﾌﾟ）
  ・コンソールから「77」を打ち込むと、無限ﾙｰﾌﾟから抜ける
@author: kenken
"""
#　---------- 初期設定 ---------------------------------------------------
#　スクレイピング用  --------------------
import urllib.request
from bs4 import BeautifulSoup
#　日経平均先物　
url="https://stocks.finance.yahoo.co.jp/stocks/detail/?code=5040469.O"
# ＤＬＬアクセス用
import sys
import time
from ctypes import *
# ＤＬＬのロード  ------------------------
lib=windll.LoadLibrary('C:/Users/kenken/AppData/Roaming/MetaQuotes/Terminal'+
                       '/FCCD626CCEAFA0C866593963E6A400F0/MQL4/Libraries'+
                       '/shared_memory.dll');
#ＤＬＬ中の関数呼び出し#戻り値型(restype)、引数型(argtypes)を指定
lib.set_a.restype=c_double
lib.set_a.argtype=None
lib.close_a.restype=c_double
lib.close_a.argtype=None
lib.write_a.restype=c_double
lib.write_a.argtypes=[c_double,c_int]
lib.read_a.restype=c_double
lib.read_a.argtype=c_int
# ＤＬＬ関数；初期設定
lib.set_a()
#---------　マルチ・スレッド用----------------
from winsound import Beep
from time import sleep
import threading
# 「global変数」の宣言　；異なるスレッド間で共有可能
flag1='99'
flag2='99'
#------------　初期設定終了　---------------------------------------------
print('\n',flush=True)
print('start flag1: %d' %int(flag1),flush=True)
print('start flag2: %d' %int(flag2),flush=True)

def scrape():
    global flag1,flag2
    # 無限ﾙｰﾌﾟ（日経平均先物のスクレイピング）
    while 1:
        #　繰り返し（ループ） #------------------------------
        res=urllib.request.urlopen(url)
        soup=BeautifulSoup(res,'html.parser')
        stoksPrice=soup.select('.stoksPrice')
        print("日経平均先物のテキスト・データ＝",stoksPrice[1].text)
        #-------読み取りデータを数値に変換する---------
        # 例；[19,985]の「,」が邪魔
        price=stoksPrice[1].text
        price1=price.replace(",","")
        price2=float(price1)
        #　ＤＬＬアクセス #　書込み　a[1]を使用
        lib.write_a(price2,1)     
        Beep(2000,500)
        sleep(5)
        if flag1=='77':
            sleep(1)
            Beep(4000,500)
            Beep(2000,500)
            print('scrapr()処理が終了しました',flush=True)
            flag2='88'
            r_ret=lib.read_a(1)
            print('DLLから読み出した値　%s,%5.2f'%(type(r_ret),r_ret))
            #　ＤＬＬ解放
            lib.close_a()
            break
        else:
            pass

def main():
    global flag1,flag2
    th=threading.Thread(target=scrape)
    th.start()
    
    if flag1=='77':
        pass
    else:
        while 1:
            input_line=input("input 「77」で終了します >>> "+"\n")
            if input_line=='77':
                print('\n ［77］が入力されました　\n',flush=True)
                break
            else:
                pass
        flag1=input_line
        Beep(3000,500)
        sleep(1)
        while 1:
            print('main2() flag1　%d' %int(flag1),flush=True)
            print('main2() flag2　%d \n' %int(flag2),flush=True)
            if flag2=='88':
                print('処理がmain2()へ戻りました',flush=True)
                break
            else:
                print('まだ、flag2　が立ってません',flush=True)
                sleep(1)

    th.join()
    #----------------------------            
    print('main2() flag1　%d' %int(flag1),flush=True)
    print('main2() flag2　%d' %int(flag2),flush=True)
    
#==================================
if __name__=='__main__':
    main()

